﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Text.Json;
using System.Net.Http.Headers;

namespace HikCentralOpenAPI
{
    public partial class Main : Form
    {
        public Main()
        {
            InitializeComponent();
            txbMessage.Text = "POST\n*/*\napplication/json; charset=utf-8\nx-ca-key:20851537\n/artemis/api/resource/v1/acsDoor/acsDoorList";
            txbSecret.Text = "0HgOMc4MH2QoiOMlFis3";
        }

        private void btnHikvisionSignature_Click(object sender, EventArgs e)
        {
            this.txbSignature.Text =  Utils.Encrypt.HikCentralSignature(txbSecret.Text, txbMessage.Text);
        }


        public async void TestService()
        {
            string stringToSign = "POST\n*/*\napplication/json; charset=utf-8\nx-ca-key:20851537\n/artemis/api/resource/v1/acsDoor/acsDoorList";
            string signature = Utils.Encrypt.HikCentralSignature("0HgOMc4MH2QoiOMlFis3", stringToSign);

            //Para que no falle porque el certificado SSL es autofirmado
            var handler = new HttpClientHandler()
            {
               ServerCertificateCustomValidationCallback = HttpClientHandler.DangerousAcceptAnyServerCertificateValidator
            };

            HttpClient httpClient = new HttpClient(handler);
    
            //Se agregan los headers
            httpClient.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("*/*"));
            httpClient.DefaultRequestHeaders.Add("x-ca-key", "20851537");
            httpClient.DefaultRequestHeaders.Add("x-ca-signature-headers", "x-ca-key");
            httpClient.DefaultRequestHeaders.Add("x-ca-signature", signature);

            //Se arma el body
            HttpRequestMessage requestMessage = new HttpRequestMessage();
            requestMessage.Content = new StringContent("{" +
                "                                       \"pageNo\": 1," +
                "                                       \"pageSize\":100" +
                "                                       }",
                                                        Encoding.UTF8, "application/json");

            //Se envia petición
            var response = await httpClient.PostAsync("https://192.168.1.102:4443/artemis/api/resource/v1/acsDoor/acsDoorList", requestMessage.Content);

            //Si fue exitosa mostramos respuesta
            if (response.IsSuccessStatusCode)
            {
                var body = await response.Content.ReadAsStringAsync();
                txbResult.Text = body;
            }


        }

        private void btnTestAPI_Click(object sender, EventArgs e)
        {
            TestService();
        }
    }
}
