<?php

namespace App\Business\HikCentral;
use App\Business\Utils\Encrypter;
use Exception;

class Visitor{

    const GUEST = 2;
    const TIMEOUT = 10;

    public static function VisitorOut($config, $appointRecordId) {
 

        $urlService = "/artemis/api/visitor/v1/visitor/out";
        $contentToSign = "POST".PHP_EOL."*/*".PHP_EOL.
        "application/json".PHP_EOL."x-ca-key:".$config->partnerKeyHikCentral.PHP_EOL.$urlService;
        
        $signature = Encrypter::HikvisionSignature($config->secretKeyHikCentral,$contentToSign);

        $client = new \GuzzleHttp\Client(
        ['verify' => false,
        'timeout' => self::TIMEOUT,
        'headers' => 
        [ 'x-ca-key' => $config->partnerKeyHikCentral,
          'x-ca-signature-headers' => "x-ca-key",
          'x-ca-signature' => $signature,
          'Content-Type'=>"application/json",
          'Accept' => "*/*"
        ]]);

        try{
        $res = $client->post($config->urlHikCentralAPI.$urlService,[ 
        \GuzzleHttp\RequestOptions::JSON => [
                                                'appointRecordId' => $appointRecordId
                                            ] 
        ]);
        }catch (\Exception $ex)
        {
            throw new Exception("Servicio no disponible intente mas tarde");
        }

        if($res->getStatusCode()!=200)
            throw new Exception("Servicio no disponible intente mas tarde");

        $response= json_decode($res->getBody());

        return $response;
        
    }
    
}



